<?php

$level = $_SESSION['level'];

require_once ('modORSearch.class.php');

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
	//post requests
	if (isset($_POST['moduleid']) && $_POST['moduleid'] == 'ors') {//module id
		if (isset($_POST['action']) && $_POST['action'] == 'search') //action
		{
			//user clicked on search button after entering some data
			if ($_POST['submit'] == 'search') {
				$resources = modORSearch::get_all_resources($_POST['title'], $_POST['sub_from'], $_POST['sub_to'], $_POST['author'], $_POST['keyword'], $_POST['type_id'], $_POST['year_from'], $_POST['year_to'], $_POST['month_from'], $_POST['month_to'], $_POST['sumtext'], $_POST['language_id'], $_POST['jour_name'], $_POST['rank_from'], $_POST['rank_to'],0,ITEMS_PER_PAGE,$rowcount,'n',$_POST['con_name'],$_POST['th_department']);
				$languages = modORResources::get_languages();
				$smarty -> assign('languages', $languages);
				$smarty -> assign('src', $_POST);
				if ($rowcount>ITEMS_PER_PAGE) {
					$smarty -> assign('next_id',2);
					$_SESSION['searchdata'] = $_POST;
				}
				$smarty -> assign('resources', $resources);
				$smarty -> assign('searched', true);
				$TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'search.tpl';
			} elseif ($_POST['submit'] == 'save search'){
			//user clicked on save search button
				modORSearch::save_search($_POST['srcname'], $_POST['title'], $_POST['sub_from'], $_POST['sub_to'], $_POST['author'], $_POST['keyword'], $_POST['type_id'], $_POST['year_from'], $_POST['year_to'], $_POST['month_from'], $_POST['month_to'], $_POST['sumtext'], $_POST['language_id'], $_POST['jour_name'], $_POST['rank_from'], $_POST['rank_to'], $_POST['con_name'], $_POST['th_department']);
				$languages = modORResources::get_languages();
				$smarty -> assign('languages', $languages);
				$smarty -> assign('src', $_POST);
				$TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'search.tpl';
			} 
		} elseif (isset($_POST['action']) && $_POST['action'] == 'smpsearch')
		//first page simple text search
		{
			$resources = modORSearch::get_all_resources_simple_search($_POST['text']);
			$languages = modORResources::get_languages();
            
            // Limit resources to 20 for simple search
            if (is_array($resources) && count($resources) > 20)
            {
                $i = 0;
                $ret = array();
                foreach ($resources as $key => $value)
                {
                    $ret[$key] = $value;
                    $i++;
                    
                    if ($i == 20)
                        break;
                }
                
                $resources = $ret;
                
                $smarty->assign('end_text', 'more than 20 results found.  please perform an advanced search above to see all.');
            }
            
			$smarty -> assign('languages', $languages);
			$smarty -> assign('resources', $resources);
			$smarty -> assign('searched', true);

			$TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'search.tpl';
		} elseif (isset($_POST['action']) && $_POST['action'] == 'massaction')
		{
			//user mark some saved searches and clicked on delete button
			if ($_POST['submit'] == 'delete')
			{
				if (is_array($_POST['selected']) && count(is_array($_POST['selected']) > 0))
					foreach ($_POST['selected'] as $key)
						modORSearch::delete_search($key);
				$smarty -> assign('searches', modORSearch::get_all_searches($_SESSION['user']));
				$TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'searches.tpl';
			} elseif ($_POST['submit'] == 'bibtex') {
                $bibtex_code = modORSearch::get_bibtex_code($_POST['bibtex']) ;
                
                if ($_POST['bibtexDownload']) {
                    header('Content-Description: File Transfer');
                    header('Content-Type: application/force-download');
                    header('Content-Length: ' . strlen($bibtex_code));
                    header('Content-Disposition: attachment; filename=bibtex.txt');
                    print($bibtex_code) ;
                    exit() ;
                } else {
                    $smarty->assign('message', '<textarea cols="80" rows="40">' . $bibtex_code . '</textarea>') ;
                    $smarty->assign('backURL', 'javascript:history.go(-1)') ;
                    $TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.'modORMessages'.DIRECTORY_SEPARATOR.'msg.tpl';
                }
            }
		}
	}
}

if ($_SERVER['REQUEST_METHOD'] === 'GET') {
//get requests
	if (isset($_GET['moduleid']) && $_GET['moduleid'] == 'ors') { //module id
		if (isset($_GET['action']) && $_GET['action'] == 'searches') { //action
			//load all searches for current user
			if ($level > 2) modORMessages::no_admin(); else {
				$smarty -> assign('searches', modORSearch::get_all_searches($_SESSION['user']));
				$TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'searches.tpl';
			}
		}elseif (isset($_GET['action']) && $_GET['action'] == 'get' && isset($_GET['item'])) {
		//load saved search
			if ($level > 2) modORMessages::no_admin(); else {
				$smarty -> assign('languages', modORResources::get_languages());
				$src = modORSearch::get_search($_GET['item']);
				$smarty -> assign('src', $src);
				$resources = modORSearch::get_all_resources($src['title'], $src['sub_from'], $src['sub_to'], $src['author'], $src['keyword'], $src['type_id'], $src['year_from'], $src['year_to'], $src['month_from'], $src['month_to'], $src['sumtext'], $src['language_id'], $src['jour_name'], $src['rank_from'], $src['rank_to'],0,ITEMS_PER_PAGE,$rowcount,'y',$src['con_name'],$src['th_department']);
				$smarty -> assign('resources', $resources);
				$TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'search.tpl';
			}
		}elseif (isset($_GET['action']) && $_GET['action'] == 'load' && isset($_GET['item'])) {
			//used when user clicks on the link provided 
			//in weekly notification email about new resources
			$smarty -> assign('languages', modORResources::get_languages());
			$src = modORSearch::get_search($_GET['item']);
			$smarty -> assign('src', $src);
			if (isset($_GET['subitem']) && $_GET['subitem']==0)
				$latest = 'y';
			else
				$latest = 'n';
			$resources = modORSearch::get_all_resources($src['title'], $src['sub_from'], $src['sub_to'], $src['author'], $src['keyword'], $src['type_id'], $src['year_from'], $src['year_to'], $src['month_from'], $src['month_to'], $src['sumtext'], $src['language_id'], $src['jour_name'], $src['rank_from'], $src['rank_to'],0,ITEMS_PER_PAGE,$rowcount,$latest,$src['con_name'],$src['th_department']);
			$smarty -> assign('resources', $resources);
			$TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'search.tpl';
		}elseif (isset($_GET['action']) && $_GET['action'] == 'key' && isset($_GET['item'])) {
				$smarty -> assign('languages', modORResources::get_languages());
				$src['keyword'] = $_GET['item'];
				$smarty -> assign('src', $src);
				$TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'search.tpl';
		}elseif (isset($_GET['action']) && $_GET['action'] == 'search' && isset($_GET['item']) && isset($_SESSION['searchdata'])) {
			$resources = modORSearch::get_all_resources($_SESSION['searchdata']['title'], $_SESSION['searchdata']['sub_from'], $_SESSION['searchdata']['sub_to'], $_SESSION['searchdata']['author'], $_SESSION['searchdata']['keyword'], $_SESSION['searchdata']['type_id'], $_SESSION['searchdata']['year_from'], $_SESSION['searchdata']['year_to'], $_SESSION['searchdata']['month_from'], $_SESSION['searchdata']['month_to'], $_SESSION['searchdata']['sumtext'], $_SESSION['searchdata']['language_id'], $_SESSION['searchdata']['jour_name'], $_SESSION['searchdata']['rank_from'], $_SESSION['searchdata']['rank_to'], ($_GET['item']-1)*ITEMS_PER_PAGE, ITEMS_PER_PAGE,$rowcount, 'n', $_SESSION['searchdata']['con_name'], $_SESSION['searchdata']['th_department']);
			$languages = modORResources::get_languages();
			$smarty -> assign('languages', $languages);
			$smarty -> assign('src', $_SESSION['searchdata']);
			if ($rowcount>($_GET['item']*ITEMS_PER_PAGE)) {
				$smarty -> assign('next_id',$_GET['item']+1);
			}
			if ($_GET['item']>1) {
				$smarty -> assign('prev_id',$_GET['item']-1);
			}
			$smarty -> assign('resources', $resources);
			$smarty -> assign('searched', true);
			$TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'search.tpl';
		} elseif (isset($_GET['action']) && $_GET['action'] == 'search') //action
        {
            //user clicked on search button after entering some data
            if ($_GET['submit'] == 'search') {
                $resources = modORSearch::get_all_resources($_GET['title'], $_GET['sub_from'], $_GET['sub_to'], $_GET['author'], $_GET['keyword'], $_GET['type_id'], $_GET['year_from'], $_GET['year_to'], $_GET['month_from'], $_GET['month_to'], $_GET['sumtext'], $_GET['language_id'], $_GET['jour_name'], $_GET['rank_from'], $_GET['rank_to'],0,ITEMS_PER_PAGE,$rowcount, 'n', $_GET['con_name'], $_GET['th_department']);
                $languages = modORResources::get_languages();
                $smarty -> assign('languages', $languages);
                $smarty -> assign('src', $_GET);
                if ($rowcount>ITEMS_PER_PAGE) {
                    $smarty -> assign('next_id',2);
                    $_SESSION['searchdata'] = $_GET;
                }
                $smarty -> assign('resources', $resources);
                $smarty -> assign('searched', true);
                $TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'search.tpl';
            } elseif ($_GET['submit'] == 'save search'){
            //user clicked on save search button
                modORSearch::save_search($_GET['srcname'], $_GET['title'], $_GET['sub_from'], $_GET['sub_to'], $_GET['author'], $_GET['keyword'], $_GET['type_id'], $_GET['year_from'], $_GET['year_to'], $_GET['month_from'], $_GET['month_to'], $_GET['sumtext'], $_GET['language_id'], $_GET['jour_name'], $_GET['rank_from'], $_GET['rank_to'], $_GET['con_name'], $_GET['th_department']);
                $languages = modORResources::get_languages();
                $smarty -> assign('languages', $languages);
                $smarty -> assign('src', $_GET);
                $TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'search.tpl';
            } 
        } elseif (isset($_GET['action']) && $_GET['action'] == 'smpsearch')
        //first page simple text search
        {
            $resources = modORSearch::get_all_resources_simple_search($_GET['text']);
            $languages = modORResources::get_languages();

            // Limit resources to 20 for simple search
            if (is_array($resources) && count($resources) > 20)
            {
                $i = 0;
                $ret = array();
                foreach ($resources as $key => $value)
                {
                    $ret[$key] = $value;
                    $i++;
                    
                    if ($i == 20)
                        break;
                }
                
                $resources = $ret;
                
                $smarty->assign('end_text', 'more than 20 results found.  please perform an advanced search above to see all.');
            }

            $smarty -> assign('languages', $languages);
            $smarty -> assign('resources', $resources);
            
            $smarty -> assign('searched', true);
            $TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'search.tpl';
        } else {
			$languages = modORResources::get_languages();
			$smarty -> assign('languages', $languages);
			$TPL_NAME = 'modules'.DIRECTORY_SEPARATOR.$MODULE_NAME.DIRECTORY_SEPARATOR.'search.tpl';
		}
	}
}

?>